#include <DateTime.h>
#include <PalmOS.h>
#include <VFSMgr.h>
#define __attribute__(a)
//#define memChunkFlagAllowLarge    0x1000
#define SEEK_SET vfsOriginBeginning
#define SEEK_CUR vfsOriginCurrent
#define SEEK_END vfsOriginEnd
#define O_EXCL vfsModeExclusive
#define O_RDONLY vfsModeWrite
#define O_WRONLY vfsModeWrite
#define O_RDWR vfsModeReadWrite
#define O_CREAT vfsModeCreate
#define O_TRUNC vfsModeTruncate
//#define off_t long
#define O_NDELAY 0
#define write_log(a) fputs(logFile,a)
typedef long unsigned int size_t;

#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
//#define atoi StrAToI
//#define malloc MemPtrNew
//#define free MemPtrFree
#define Uint8 UInt8
#define LOG_MSG //
#define LOG_DMA(a)
#define LOG_NORMAL(a)
#define LOG(a,b)
#define fmod(a,b) (a/b-(int)(a/b))
#define __cdecl
//int	 strcoll(const char *, const char *);
//long	 strxfrm(char *, const char *, long);
//char 	*strerror(int);
//int isspace(int);

struct sched_param1
{
  int sched_priority;
};

typedef struct {
  int is_initialized;
  void *stackaddr;
  int stacksize;
  int contentionscope;
  int inheritsched;
  int schedpolicy;
  struct sched_param1 schedparam;
  int  detachstate;

} pthread_attr_t;
typedef UInt32 pthread_t;
typedef UInt32 pthread_cond_t;
typedef UInt32 pthread_key_t;
typedef UInt32 pthread_mutex_t;

typedef struct {
  int   is_initialized;  /* is this structure initialized? */
  int   init_executed;   /* has the initialization routine been run? */
} pthread_once_t;       /* dynamic package initialization */

typedef struct {
  int   is_initialized;
} pthread_condattr_t;         /* a condition attribute object */

typedef struct {
  int   is_initialized;
  int   recursive;
} pthread_mutexattr_t;


double atof (const char *S);
//typedef char* string ;
//typedef long size_t;
float floor(float);
float ceil( float x );
float sin( float xx );
float cos( float xx );
float sqrt( float xx );
float atan2( float y, float x );
float tan( float x );
float pow( float x, float y );
float log( float xx );
static inline float fabs(float f) {if (f>=0) return f; return -f;}
//Int32 fwrite(FILE *fp, UInt32 size, UInt32 nmemb, void* buff);
//Int32 fseek(FILE *fp,Int32 offset,Int32 orig);
//int fclose(FILE *fp);
struct tm
{
  int	tm_sec;
  int	tm_min;
  int	tm_hour;
  int	tm_mday;
  int	tm_mon;
  int	tm_year;
  int	tm_wday;
  int	tm_yday;
  int	tm_isdst;
};
typedef long time_t;
#define _COMPILING_NEWLIB
#define __FLT_HAS_INFINITY__ false
#define __FLT_HAS_QUIET_NAN__ false
#define __DBL_HAS_INFINITY__ false
#define __DBL_HAS_QUIET_NAN__ false
#define __LDBL_HAS_INFINITY__ false
#define __LDBL_HAS_QUIET_NAN__ false
//#define has_quiet_NaN false

#define SET_SEL_REG(trap) ((unsigned long*)(gEmulStateP))[3] = (trap)
/*
Int16 StrCompare( const Char* s1, const Char* s2 );
Char* StrCopy( Char* , const Char*  );
Int16 StrNCompare( const Char* , const Char* , Int32  );
Char* StrCat( Char* dst, const Char* src );
Err MemMove( void* dstP, const void* sP, Int32 numBytes );
UInt16 StrLen( const Char* src );
Err MemSet( void* dstP, Int32 numBytes, UInt8 value );
Err VFSFileRead( FileRef fileRef, UInt32 numBytes, void* bufP, UInt32* numBytesReadP );
Err VFSFileClose( FileRef fileRef );
Err VFSFileOpen( UInt16 volRefNum, const Char* pathNameP, UInt16 openMode, FileRef* fileRefP );
Err VFSFileSeek( FileRef fileRef, FileOrigin origin, Int32 offset );
Err VFSFileTell( FileRef fileRef, UInt32* filePosP );
Int16 MemCmp( const void* s1, const void* s2, Int32 numBytes );
UInt32 TimGetSeconds( void );
void TimSecondsToDateTime( UInt32 seconds, DateTimeType* dateTimeP );
Int16 StrCaselessCompare( const Char* s1, const Char* s2 );
Err VFSFileSize( FileRef fileRef, UInt32* fileSizeP );
Err VFSFileGetAttributes( FileRef fileRef, UInt32* attributesP );
Err VFSFileGetDate( FileRef fileRef, UInt16 whichDate, UInt32* dateP );
Err VFSFileWrite( FileRef fileRef, UInt32 numBytes, const void* dataP, UInt32* numBytesWrittenP );
Err VFSFileResize( FileRef fileRef, UInt32 newSize );
*/
char *strchr (const char *s,int c);
char *strrchr (const char *s,int c);
//int fprintf(FILE *fp, const char *fmt, ...);

unsigned long Byte_Swap32( unsigned long l );
unsigned short Byte_Swap16( unsigned short l );
void write_unaligned32( unsigned char* dest, unsigned long val );
void write_unaligned16( unsigned char* dest, unsigned short val );
unsigned short  read_unaligned16( const unsigned char* src );
unsigned long read_unaligned32( const unsigned char* src );
void SWAP_DATETIMETYPE_68K_TO_ARM (char *dest, char *src);
void SWAP_FILEINFOTYPE (char *dest, char *src);
//char *fgets(char *s, int n, FILE *stream);
extern Err err;
static inline int toupper (int C)
{
	C-=(((C>='a')&&(C<='z'))? ('a'-'A') : 0);
	return C;
}

static inline int tolower (int C)
{
	C+=(((C>='A')&&(C<='Z'))? ('a'-'A') : 0);
	return C;
}

struct stat {
	UInt32 attributes;
	UInt32 date;
	UInt32 filesize;
	UInt32 st_mode;
	UInt32 st_size;
	time_t st_mtime;
};
#define S_IFDIR vfsFileAttrDirectory
typedef void DIR;
//int stat (char* name, struct stat *statbuf);
char *my_strdup (const char *s);
typedef unsigned long long __ino64_t;
extern UInt16 volumeRef;
extern FileRef logFile;

/*
typedef struct EventTyp {
   UInt16           eType;
   Boolean        penDown;
   UInt8          tapCount;
   Int16          screenX;
   Int16          screenY;
   union {
      struct _GenericEventType          generic;
      struct _PenUpEventType        penUp;
      struct _KeyDownEventType      keyDown;
          struct _KeyUpEventType                keyUp;
          struct _KeyHoldEventType              keyHold;
      struct _WinEnterEventType     winEnter;
      struct _WinExitEventType      winExit;
      struct _TSMConfirmType                    tsmConfirm;
      struct _TSMFepButtonType          tsmFepButton;
      struct _TSMFepModeEventType       tsmFepMode;

      struct ctlEnter ctlEnter;

      struct ctlSelect ctlSelect;

      struct ctlRepeat ctlRepeat;

      struct ctlExit  ctlExit;

      struct fldEnter fldEnter;

      struct fldHeightChanged fldHeightChanged;

      struct fldChanged fldChanged;

      struct fldExit fldExit;

      struct lstEnter lstEnter;

      struct lstExit lstExit;

      struct lstSelect lstSelect;

      struct tblEnter tblEnter;

      struct tblExit tblExit;

      struct tblSelect tblSelect;

      struct frmLoad frmLoad;

      struct frmOpen frmOpen;

      struct frmGoto frmGoto;

      struct frmClose frmClose;

      struct frmUpdate frmUpdate;

      struct frmObjectFocusTake frmObjectFocusTake;

      struct frmObjectFocusLost frmObjectFocusLost;

      struct frmTitleEnter frmTitleEnter;

      struct frmTitleSelect frmTitleSelect;

       struct attnIndicatorEnter attnIndicatorEnter;

     struct attnIndicatorSelect attnIndicatorSelect;

      struct daySelect daySelect;

      struct menu menu;

      struct popSelect popSelect;

      struct sclEnter sclEnter;

      struct sclExit sclExit;

      struct sclRepeat sclRepeat;

                struct menuCmdBarOpen  menuCmdBarOpen;

                struct menuOpen  menuOpen;

                struct gadgetEnter gadgetEnter;

                struct gadgetMisc  gadgetMisc;

                struct winDisplayChanged  winDisplayChanged;

      } data;

} EventTyp;
*/
#include <stdarg.h>
typedef void FILE;
Int32 ftell(FILE *fp);
int fprintf(FILE *fp, const char *fmt, ...);
Int32 WRite(UInt32 fh, UInt32 nbytes, UInt32 nstr, char* buff);
Int32 fwrite(unsigned char* buff, UInt32 size, UInt32 nmemb, FILE *fp);
Int32 fread(void* buff, UInt32 size, UInt32 nmemb, FILE *fp);
char *fgets(char* buff, int nbytes, FILE *fp);
void puts(char* buff);
//Int32 fputs(char* buff, FILE *fp);
//Int32 fputc(int ch, FILE *fp);
int vsprintf (char *, const char *, va_list);
int sprintf (char *, const char *, ...);

Int32 fseek(FILE *fp,Int32 offset,Int32 orig);
int fclose(FILE *fp);
FILE *fopen(const char* path, char* flags);
//#undef FILE
char *my_strtok(char *s, const char *delim);
extern "C" void __cxa_pure_virtual(void);
//#undef FILE
#define exit(x)
#define strcasecmp StrCaselessCompare
#define strncasecmp StrNCaselessCompare
#define strcpy StrCopy
#define strncmp StrNCompare
#define strcmp StrCompare
#define strcat StrCat
#define memcpy MemMove
#define memcmp MemCmp
#define strlen StrLen
#define memset(x,y,z) MemSet (x,z,y)
#define strncpy StrNCopy
#define strstr StrStr
#define strncat StrNCat
#define memmove MemMove
#define malloc m_alloc
#define free m_free
#define atoi StrAToI
#define rand() SysRandom(0)
#define strdup my_strdup
//#define vsprintf StrVPrintF
#define mode_t UInt32
#define F_OK 0xA0A0A0A0
void  *m_alloc (long);
void m_free(void*);
int isspace (int);
int isalpha(int);
char *my_strdup(const char *s);
int rmdir (const char *path);
int mkdir (const char *path, mode_t mode);
struct tm* localtime(const time_t *clock);
int access (const char *path,int mode);
int rename (const char *old, const char *newname);
int ftruncate (FileRef fr, long length);
FileRef fileno(FILE *fr);
