#define sysTrapWinGetBitmap 0xA3A2
#define sysTrapWinPaintBitmap 0xA380
#define sysTrapSndCreateMidiList 0xA2AE
#define sysTrapSndDoCmd 0xA233
#define sysTrapFplFToA 0xA0E1
#define sysTrapMemNumCards 0xA03A
#define sysTrapMemCardInfo 0xA004
#define commandKeyMask 0x0008
#define vchrMenu 0x0105

typedef unsigned long Call68KFuncType(const void *emulStateP, unsigned long trapOrFunction,
	const void *argsOnStackP, unsigned long argsSizeAndwantA0);
typedef unsigned long NativeFuncType(const void* emulStateP, void *userData68KP,
	Call68KFuncType *call68KFuncType);
void WinDrawPixel (Coord x,Coord y) SYS_TRAP (sysTrapWinDrawPixel);
BitmapType *WinGetBitmap (WinHandle winHandle) SYS_TRAP (sysTrapWinGetBitmap);
void WinPaintBitmap(BitmapType *bitmapP, Coord x,Coord y) SYS_TRAP (sysTrapWinPaintBitmap);
Boolean SndCreateMidiList(UInt32 creator, Boolean multipleDBs, UInt16 *recordCount,
		MemHandle *recordList) SYS_TRAP (sysTrapSndCreateMidiList);
Err SndDoCmd (void *channelP, SndCommandPtr commandP, Boolean noWait) SYS_TRAP (sysTrapSndDoCmd);
Err FplFToA (double val, char *charP) SYS_TRAP (sysTrapFplFToA);
UInt16 MemNumCards(void) SYS_TRAP (sysTrapMemNumCards);
Err MemCardInfo(UInt16 cardNo,Char* cardNameP,Char* manufNameP,UInt16* versionP,UInt32* crDateP,
		UInt32* romSizeP,UInt32* ramSizeP,UInt32* freeBytesP) SYS_TRAP (sysTrapMemCardInfo);
Err MemHeapFreeBytes (UInt16,UInt32*,UInt32*) SYS_TRAP (0xA00B);
MemPtr MemChunkNew(UInt16,UInt32,UInt16)  SYS_TRAP (0xA011);
UInt16 MemNumHeaps(UInt16)  SYS_TRAP (0xA007);
UInt16 MemHeapFlags(UInt16)  SYS_TRAP (0xA00D);
Err MemChunkFree(MemPtr)  SYS_TRAP (0xA012);
UInt32 PceNativeCall(NativeFuncType *,void *) SYS_TRAP(0xA45A);
SysAppInfoPtr SysGetAppInfo(SysAppInfoPtr *,SysAppInfoPtr *) SYS_TRAP(0xA33C);
Err FtrPtrNew (UInt32, UInt16, UInt32, void **) SYS_TRAP (0xA35A);
Err FtrPtrFree (UInt32, UInt16) SYS_TRAP (0xA35B);
WinHandle WinGetDisplayWindow (void) SYS_TRAP (0xA200);
Err DmWriteCheck(void*, UInt32, UInt32) SYS_TRAP (0xA079);
MemHandle MemPtrRecoverHandle (MemPtr) SYS_TRAP (0xA014);
void LstDrawList(ListType *pList) SYS_TRAP (sysTrapLstDrawList);
void LstSetDrawFunction(ListType*,ListDrawDataFuncPtr) SYS_TRAP (sysTrapLstSetDrawFunction);
Err EvtSetAutoOffTimer(EvtSetAutoOffCmd cmd, UInt16 timeout) SYS_TRAP (0xA3AD);
Err EvtResetAutoOffTimer () SYS_TRAP(0xA130);
UInt32 MemPtrSize(MemPtr p) SYS_TRAP (0xA016);
Boolean EvtKeyQueueEmpty() SYS_TRAP (0xA131);
MemHandle DmGet1Resource(DmResType,DmResID) SYS_TRAP (0xA060);
MemHandle DmResizeResource (MemHandle, UInt32) SYS_TRAP (0xA062);
void CtlSetUsable(ControlType *controlP, Boolean usable) SYS_TRAP(sysTrapCtlSetUsable);
Err EvtEnqueueKey(WChar ascii,UInt16 kcode,UInt16 mods) SYS_TRAP (0xA12D);

